<template>
  <el-row v-loading="loading">
    <el-form
      :model="routeForm"
      status-icon
      :rules="rules"
      ref="routeForm"
      label-width="120px"
      v-if="routeForm && routeForm.id"
    >
      <el-form-item required label="Departure city" prop="cityA">
        <el-input v-model="routeForm.cityA"></el-input>
      </el-form-item>
      <el-form-item required label="Destination city" prop="cityB">
        <el-input v-model="routeForm.cityB"></el-input>
      </el-form-item>
      <el-form-item required label="Distance, km" prop="distance">
        <el-input v-model.number="routeForm.distance"></el-input>
      </el-form-item>
      <el-form-item
        required
        label="Expected revenue, $"
        prop="expected_revenue"
      >
        <el-input v-model.number="routeForm.expected_revenue"></el-input>
      </el-form-item>
      <el-form-item required label="Car type" prop="car_type_id">
        <el-select
          v-model="routeForm.car_type_id"
          placeholder="Choose required car type"
        >
          <el-option label="Passenger" :value="0"></el-option>
          <el-option label="Freight" :value="1"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="Dispatch date" prop="date_start">
        <el-date-picker
          v-model="routeForm.date_start"
          type="datetime"
          placeholder="Select date and time"
        >
        </el-date-picker>
      </el-form-item>

      
      <el-divider></el-divider>

      <el-form-item required label="Responsible car" prop="car_id">
        <el-autocomplete
          :fetch-suggestions="loadSuitableCars"
          @select="handleSelectCar"
          value-key="registration_mark"
          v-model.number="routeForm.car_id"
        >
          <template slot-scope="{ item }">
            <div class="value">{{ item.registration_mark }}</div>
            <span class="link">{{ 'Bought in: ' + $moment(item.purchase_date).format('yyyy-MM-DD') }}</span>
          </template>
        </el-autocomplete>
      </el-form-item>
      
      
      <el-form-item>
        <el-button type="primary" @click="handleSaveRoute">Save</el-button>
      </el-form-item>

    </el-form>
    <el-col v-else-if="!loading">
      Not found route with id: <b>{{ id }}</b>
    </el-col>
    <el-col v-else>
      <span v-loading="true"></span>
    </el-col>
    <pre>{{routeForm}}</pre>
  </el-row>
</template>

<script>
  import routeModelMixin from "@/mixins/routeModelMixin";
  import { ACTIONS_UPDATE_ROUTE } from "@/plugins/constants";
  import { mapActions } from "vuex";

  export default {
    mixins: [routeModelMixin],
    methods: {
      ...mapActions({ ACTIONS_UPDATE_ROUTE }),
      loadSuitableCars(query, cb) {
        this.$axios(`/cars/type/${this.routeForm.car_type_id}`).then(
          ({ data }) => {
            cb(data);
          }
        );
      },
      handleSelectCar(car) {
        this.routeForm.new_car_id = car.id;
      },
      handleSaveRoute() {
        this.ACTIONS_UPDATE_ROUTE(this.routeForm)
          .then((_) =>
            this.$router.push({ name: "Route", params: { id: this.id } })
          )
          .catch(({ response }) =>
            this.$notify.error({ message: response.data })
          );
      },
    },
  };
</script>

<style scoped>
  .error {
    color: tomato;
  }

  .el-input {
    margin: 3px;
    padding: 5px;
  }
</style>